/*




  Funo 
	validarConteudo

  Parmetros
  	evento: Obrigatrio, do tipo event. Recebe o valor de uma varivel do navegador que guarda o evento do teclado.
	tipo: Obrigatrio, do tipo String. Recebe o nome do tipo de validao que deve ser feita. Valores possveis: numero, texto ou textoNumerico.

  Funcionalidade
	No permite a entrada de caracteres invlidos.

  Exemplo de utilizao
 	<input type="text" name="tfValor" size="11" maxlength="11" onKeyPress="return(validarConteudo(event, 'numero'))">

  Observao
	O retorno false no permite a entrada do caractere no respectivo textField.	
*/
function validarConteudo(evento, tipo, campo)
{
	var entrada;
	var navegador = navigator.appName;

	if (navegador.indexOf("Netscape") != -1)
	{
		entrada = String.fromCharCode(evento.which);
	}
	else
	{
		entrada = String.fromCharCode(evento.keyCode);
	}
	
	if (navegador.indexOf("Netscape") && evento.which == 8)
		return true;


	if(tipo == "numero")
	{
		return (validarNumero(entrada));
	}
	else
	{
		if( tipo == "float" ) 
		{
			if( entrada == "," && campo != null )
			{
				var indexVirgula =  campo.value.indexOf(",");
				if( indexVirgula != -1 ) {
					return false;
				}
			}	
			else {
				return (validarFloat(entrada));
			}
		}
		
		if (tipo == "texto")
		{
			return (validarTexto(entrada));
		}
		else 
		{			
			if (tipo == "textoNumerico")
			{
				return (validarTextoNumerico(entrada));
			}
		}
	}
}

/*
  Funo 
	validarNumero

  Parmetros
  	conteudo: Obrigatrio, do tipo String. Recebe o caracter correspondente ao evento do teclado.

  Funcionalidade
	No permite a entrada de caracteres que no sejam numricos.

  Exemplo de utilizao
	validarNumero(entrada)
*/
function validarNumero(conteudo)
{
	var validos = "0123456789";
	var valor = new String(conteudo);

	for (var i = 0; i < valor.length; i++)
	{
		if (validos.indexOf(valor.charAt(i)) == -1)
			return false;
	}

	return true;
}

/*
  Funo 
	validarTexto

  Parmetros
  	conteudo: Obrigatrio, do tipo String. Recebe o caracter correspondente ao evento do teclado.

  Funcionalidade
	No permite a entrada de caracteres que no sejam alfabticos.

  Exemplo de utilizao
	validarTexto(entrada)

  Observacao
	Exceto os caracteres (),./ os demais como ! @ # $ so tratados como caracteres especiais.
*/
function validarTexto(conteudo)
{
	return validarTextoNumero(conteudo, false);
}

/*
  Funo 
	validarTextoNumerico

  Parmetros
  	conteudo: Obrigatrio, do tipo String. Recebe o caracter correspondente ao evento do teclado.

  Funcionalidade
	No permite a entrada de caracteres que no sejam alfabticos ou numricos.

  Exemplo de utilizao
	validarTexto(entrada)

  Observacao
	Exceto os caracteres (),./ os demais como ! @ # $ so tratados como caracteres especiais.
*/
function validarTextoNumerico(conteudo)
{
	return validarTextoNumero(conteudo, true);
}

/*
 Funo 
	validarTextoNumero

  Parmetros
  	conteudo: Obrigatrio, do tipo String. Recebe o caracter correspondente ao evento do teclado.
	textoNumerico: Obrigatrio, do tipo boolean (true ou false). Indica se o tipo de validao  s para texto(false) ou texto numrico(true).

  Funcionalidade
	Valida caracteres para o tipo de validao escolhida: false = Texto ou true = texto numrico.

  Exemplo de utilizao
	validarTextoNumero(conteudo, false)
*/
function validarTextoNumero(conteudo, textoNumerico)
{
	var valor = String(conteudo);
	var acentosMinusculos = new String("");
	var acentosMaiusculos = new String("");
	var outrosCaracteres = new String("/().,");
	var numerico = new RegExp("[0-9]");
	var texto = new RegExp("[A-Za-z]");

	for (var i = 0; i < valor.length; i++)
	{
		var letra = new String(valor.charAt(i));

		if (letra != " " && !texto.test(letra)) 
		{
			if ((acentosMinusculos.indexOf(letra) == -1) && (acentosMaiusculos.indexOf(letra) == -1) && (outrosCaracteres.indexOf(letra) == -1))
			{
				if (textoNumerico) // Se tipo  texto numrico, ainda pode ser nmero.
				{
					if (!numerico.test(letra)) 
						return false;
				}
				else 
					return false;                                
			}
		}
	}

	return true;
}
/*
  Funo 
	validarFloat

  Parmetros
  	conteudo: Obrigatrio, do tipo String. Recebe o caracter correspondente ao evento do teclado.

  Funcionalidade
	No permite a entrada de caracteres que no sejam numricos e permite a digitao do caracter '.' (ponto)

  Exemplo de utilizao
	validarFloat(entrada)
*/
function validarFloat(conteudo)
{
	var validos = "0123456789,";
	var valor = new String(conteudo);

	for (var i = 0; i < valor.length; i++)
	{
		if (validos.indexOf(valor.charAt(i)) == -1)
			return false;
	}

	return true;
}

/**
 * Formata um valor float para apresentar um determinado nmero de casas decimais.
 */	
function formatValueFloat(valor,casas)
{
	if( casas == null ) {
		casas = 2; //default
	}
	
	var valor_str = valor.toString();

	if( valor_str == "" )
		return valor_str;

	//procura o separador decimal -> definido como sendo a vrgula
	var indexSeparator = valor_str.indexOf(',');
	
	if( indexSeparator != -1)
	{
		var valorp1 = valor_str.substring(0,indexSeparator);
		var valorp2 = valor_str.substring(indexSeparator+1);
		
		var casasZero = "";
		if( valorp2.length < casas ) 
		{
			var numeroCasas = casas;
			while( numeroCasas > valorp2.length ) {
				casasZero += "0";
				numeroCasas--;
			}
			valorp2 = valorp2 + casasZero;		
		}
		else
		{
			valorp2 = valorp2.substring(0,casas);
		}
		//--return valorp1 + "." + valorp2;
		return valorp1 + "," + valorp2;
	}
	else 
	{
		var valorp2 = "00";
		while( valorp2.length < casas )	{
			valorp2 += "0";
		} 

		//--return valor + "." + valorp2;
		return valor + "," + valorp2;
	}
}
/**
 * Preenche o campo com o valor formatado.
 * Utiliza a funcao formatValueFloat
 */
function formatValueFloatField(campo,casas)
{
	if( casas == null ) {
		casas = 2;
	}

	campo.value = formatValueFloat(campo.value,casas);
}	
